
using StandaloneIpopt

# hs071
#
# min  x1*x4*(x1+x2+x3)+x3
# s.t. x1*x2*x3*x4 >= 25
#      x1^2 + x2^2 + x3^2 + x4^2 == 40
#      1 <= x1, x2, x3, x4 <= 5

# Objective:
obj(x) = x[1]*x[4] * (x[1]+x[2]+x[3]) + x[3]

# constraints:
con1 = [25.0, 1e22] => (x -> prod(x))
con2 = [40.0, 40.0] => (x -> sum(abs2, x))

# box values, the same for all parameters. If they weren't, you could instead
# pass in box_lower = [l_1, l_2, ..., l_n].
(b_l, b_u) = (1.0, 5.0)

# init value:
ini = [1.0, 5.0, 5.0, 1.0]

# result:
res = ipopt_optimize(obj, ini, Constraints((con1, con2)),
                     box_lower=b_l, box_upper=b_u)

