
struct AutoFwdConDerivatives{F}
  cons::Constraints{F}
end

function _con_jacobian(jacbuf, conbuf, CD::AutoFwdConDerivatives{F}, x) where{F}
  cons = CD.cons
  ForwardDiff.jacobian!(jacbuf, CD.cons.fun, conbuf, x)
end

function _con_lagpart_hess(hesbuf, lam, CD::AutoFwdConDerivatives{F}, x) where{F}
  cons = CD.cons
  ncon = cons.ncon
  lagrange_con = x -> begin
    innerbuf = zeros(eltype(x), cons.ncon)
    cons.fun(innerbuf, x)
    dot(view(lam, 1:cons.ncon), innerbuf)
  end
  ForwardDiff.hessian!(hesbuf, lagrange_con, x)
end

