
struct Constraints{F}
  ncon::Int64
  fun::F
  box_lower::Vector{Float64}
  box_upper::Vector{Float64}
end

struct Problem{O,F}
  objective::O
  constraints::Constraints{F}
end

function Constraints(tuple_of_scalarcons)
  lowers = [x.first[1] for x in tuple_of_scalarcons]
  uppers = [x.first[2] for x in tuple_of_scalarcons]
  n      = length(uppers)
  funs   = ntuple(j->tuple_of_scalarcons[j].second, n)
  vec_eval(store, p) = begin
    for j in eachindex(funs)
      store[j] = funs[j](p)
    end
    nothing
  end
  Constraints(n, vec_eval, lowers, uppers)
end

noconstraints() = Constraints(0, (args...)->nothing, Float64[], Float64[])

