
# A very simple test to check the zero finder. As an added bonus, we add an
# extra keyword because the problem is quadratic:

const M = Symmetric([exp(-abs(x-y)) for x in 1:10, y in 1:10])
const c = [cos(x) for x in 1:10]
obj(v)  = dot(v, M, v) + dot(v, c)
objg(buf, v) = ForwardDiff.gradient!(buf, obj, v)

# Fit the objective normally for comparison:
res_opt = ipopt_optimize(obj, normalize(ones(length(c))), 
                         print_level=0, hessian_constant="yes")

# Now obtain the minimizer using the nlsolver on the gradient of the objective:
res_nl  = ipopt_nlsolve(objg, normalize(ones(length(c))), print_level=0)

@testset "nlsolver" begin
  @test res_opt.minimizer ≈ res_nl.minimizer
end

